#include <stdio.h>

#define identifier_max 31 //WARNING: I strongly advise not making this value smaller
#define arguments_max 10
#define members_max 64

//NOTE: there are things to remove from the asm once it is compiled!

//Replace-string: mov BYTE PTR [rbx], 0 to /**/
//fix at end: imul rdx,... and following instructions to use rcx instead

typedef struct {
    char name[identifier_max];
    unsigned char* pntr;
    int amnt;
    short typeUse;
} seashell_var;

typedef struct {
    char name[identifier_max];
    char args;
    unsigned char* pntr;
    short argTypes[arguments_max];
    int argAmnts[arguments_max];
    short typeReturn;
} seashell_func;

typedef struct {
    char name[identifier_max];
    char members;
    int sizes[members_max];
    char floaty[members_max];
    short sizeTot;
} seashell_type;

void INTERNAL_funcCall(seashell_var* takeVars, seashell_func* takeFuncs, seashell_type* takeTypes, int takeFuncNumb, seashell_var* takeReturnLoc, seashell_var* takeArgsLoc)
{
    seashell_var* vars = takeVars;
    seashell_func* funcs = takeFuncs;
    seashell_type* types = takeTypes;
    int funcNumb = takeFuncNumb;
    seashell_var* argsLoc = takeArgsLoc;
    int retType = funcs[funcNumb].typeReturn;
    register int args = funcs[funcNumb].args;
    register unsigned char* location = funcs[funcNumb].pntr;
    register unsigned char* tempLocl = NULL;
    seashell_var ret;
    register seashell_var* returnLoc = takeReturnLoc;
    
    if (location != NULL) { //quick err check (shouldnt be neccessary)
	if (args == 0 && retType == -1) { //no return, no args
	    asm("call\tr12");
	} else if (args == 0 && retType >= 0) { //return, no args
	    int retSize = types[retType].sizeTot;

	    tempLocl = returnLoc->pntr;
	    *tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! "mov byte ptr[rbx], 0"
	    //(this tricks optimizer into including these instructions)
	    
	    if (retSize > 8) { //if size is too great, input pointer to rcx
	        asm("mov\trcx, rbx");
	    }
	    
	    //call
	    asm("call\tr12");

	    if (retSize <= 8) { //get ouput
		asm("mov\tQWORD PTR [rbx], rax");
	    } else {
		tempLocl = returnLoc->pntr;
		*tempLocl = 0;
		asm("mov\trcx, rbx");
	        asm("mov\trdx, rax");
		asm("xor\tr8, r8");
		asm("mov\tr8d, DWORD PTR -48[rbp]");
		asm("call\tmemcpy");
	    }
	} else if ((args >= 1 && retType == -1) || (args >= 1 && types[retType].sizeTot <= 8)) { //just args or simple return
	    if (args >= 1) {
		tempLocl = argsLoc[0].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[0]].sizeTot > 8) {
		    asm("mov\trcx, rbx");
		} else {
		    asm("mov\trcx, QWORD PTR [rbx]");
		}
	    }
	    if (args >= 2) {
		tempLocl = argsLoc[1].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[1]].sizeTot > 8) {
		    asm("mov\trdx, rbx");
		} else {
		    asm("mov\trdx, QWORD PTR [rbx]");
		}
	    }
	    if (args >= 3) {
		tempLocl = argsLoc[2].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[2]].sizeTot > 8) {
		    asm("mov\tr8, rbx");
		} else {
		    asm("mov\tr8, QWORD PTR [rbx]");
		}
	    }
	    if (args >= 4) {
		tempLocl = argsLoc[3].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[3]].sizeTot > 8) {
		    asm("mov\tr9, rbx");
		} else {
		    asm("mov\tr9, QWORD PTR [rbx]");
		}
	    }
	    if (args >= 5) {
		tempLocl = argsLoc[4].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[4]].sizeTot > 8) {
		    asm("mov\tQWORD PTR 32[rsp], rbx");
		} else {
		    asm("mov\trax, QWORD PTR [rbx]");
		    asm("mov\tQWORD PTR 32[rsp], rax");
		}
	    }
	    if (args >= 6) {
		tempLocl = argsLoc[5].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[5]].sizeTot > 8) {
		    asm("mov\tQWORD PTR 40[rsp], rbx");
		} else {
		    asm("mov\trax, QWORD PTR [rbx]");
		    asm("mov\tQWORD PTR 40[rsp], rax");
		}
	    }
	    if (args >= 7) {
		tempLocl = argsLoc[6].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[6]].sizeTot > 8) {
		    asm("mov\tQWORD PTR 48[rsp], rbx");
		} else {
		    asm("mov\trax, QWORD PTR [rbx]");
		    asm("mov\tQWORD PTR 48[rsp], rax");
		}
	    }
	    if (args >= 8) {
		tempLocl = argsLoc[7].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[7]].sizeTot > 8) {
		    asm("mov\tQWORD PTR 56[rsp], rbx");
		} else {
		    asm("mov\trax, QWORD PTR [rbx]");
		    asm("mov\tQWORD PTR 56[rsp], rax");
		}
	    }
	    if (args >= 9) {
		tempLocl = argsLoc[8].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[8]].sizeTot > 8) {
		    asm("mov\tQWORD PTR 64[rsp], rbx");
		} else {
		    asm("mov\trax, QWORD PTR [rbx]");
		    asm("mov\tQWORD PTR 64[rsp], rax");
		}
	    }
	    if (args >= 10) {
		tempLocl = argsLoc[7].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[9]].sizeTot > 8) {
		    asm("mov\tQWORD PTR 72[rsp], rbx");
		} else {
		    asm("mov\trax, QWORD PTR [rbx]");
		    asm("mov\tQWORD PTR 72[rsp], rax");
		}
	    }

	    asm("call\tr12");

	    if (retType != -1) {
		tempLocl = returnLoc->pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		asm("mov\tQWORD PTR [rbx], rax");
	    }
	} else if (args >= 1 && types[retType].sizeTot > 8) { //large return and args
	    tempLocl = returnLoc->pntr;
	    *tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
	    asm("mov\trcx, rbx");
	    
	    if (args >= 1) {
		tempLocl = argsLoc[0].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[0]].sizeTot > 8) {
		    asm("mov\trdx, rbx");
		} else {
		    asm("mov\trdx, QWORD PTR [rbx]");
		}
	    }
	    if (args >= 2) {
		tempLocl = argsLoc[1].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[1]].sizeTot > 8) {
		    asm("mov\tr8, rbx");
		} else {
		    asm("mov\tr8, QWORD PTR [rbx]");
		}
	    }
	    if (args >= 3) {
		tempLocl = argsLoc[2].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[2]].sizeTot > 8) {
		    asm("mov\tr9, rbx");
		} else {
		    asm("mov\tr9, QWORD PTR [rbx]");
		}
	    }
	    if (args >= 4) {
		tempLocl = argsLoc[3].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[3]].sizeTot > 8) {
		    asm("mov\tQWORD PTR 32[rsp], rbx");
		} else {
		    asm("mov\tr9, QWORD PTR [rbx]");
		}
	    }
	    if (args >= 5) {
		tempLocl = argsLoc[4].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[4]].sizeTot > 8) {
		    asm("mov\tQWORD PTR 32[rsp], rbx");
		} else {
		    asm("mov\trax, QWORD PTR [rbx]");
		    asm("mov\tQWORD PTR 32[rsp], rax");
		}
	    }
	    if (args >= 6) {
		tempLocl = argsLoc[5].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[5]].sizeTot > 8) {
		    asm("mov\tQWORD PTR 40[rsp], rbx");
		} else {
		    asm("mov\trax, QWORD PTR [rbx]");
		    asm("mov\tQWORD PTR 40[rsp], rax");
		}
	    }
	    if (args >= 7) {
		tempLocl = argsLoc[6].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[6]].sizeTot > 8) {
		    asm("mov\tQWORD PTR 48[rsp], rbx");
		} else {
		    asm("mov\trax, QWORD PTR [rbx]");
		    asm("mov\tQWORD PTR 48[rsp], rax");
		}
	    }
	    if (args >= 8) {
		tempLocl = argsLoc[7].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[7]].sizeTot > 8) {
		    asm("mov\tQWORD PTR 56[rsp], rbx");
		} else {
		    asm("mov\trax, QWORD PTR [rbx]");
		    asm("mov\tQWORD PTR 56[rsp], rax");
		}
	    }
	    if (args >= 9) {
		tempLocl = argsLoc[8].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[8]].sizeTot > 8) {
		    asm("mov\tQWORD PTR 64[rsp], rbx");
		} else {
		    asm("mov\trax, QWORD PTR [rbx]");
		    asm("mov\tQWORD PTR 64[rsp], rax");
		}
	    }
	    if (args >= 10) {
		tempLocl = argsLoc[7].pntr;
		*tempLocl = 0; //REMOVE FROM ASM AFTER COMPILE!! (same as above)
		if (types[funcs[funcNumb].argTypes[9]].sizeTot > 8) {
		    asm("mov\tQWORD PTR 72[rsp], rbx");
		} else {
		    asm("mov\trax, QWORD PTR [rbx]");
		    asm("mov\tQWORD PTR 72[rsp], rax");
		}
	    }

	    asm("call\tr12");
	    asm("mov\trdx, rax");

	    //NOTE: on mingw64, around here some instructions dealing with rdx will be generated, replace this with rcx, please
	    
	    int retSize = types[retType].sizeTot;
	    tempLocl = returnLoc->pntr;
	    *tempLocl = 0;
	    asm("mov\trcx, rbx");
	    asm("xor\tr8, r8");
	    asm("mov\tr8w, WORD PTR -52[rbp]"); //this ensures we are within size limit defined (64k)
	    asm("call\tmemcpy");
	}
    }
}
